unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, ExtCtrls, pngimage, StdCtrls, Gauges, DXInput, Spin;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Panel2: TPanel;
    Modul: TImage;
    Plocha: TShape;
    ZemJeLava: TShape;
    Timer1: TTimer;
    IdHTTP1: TIdHTTP;
    Memo1: TMemo;
    LabelX: TLabel;
    LabelY: TLabel;
    LabelVx: TLabel;
    LabelVy: TLabel;
    LabelL: TLabel;
    LabelR: TLabel;
    Palivo: TGauge;
    DXInput1: TDXInput;
    Status1: TLabel;
    Status2: TLabel;
    ModulNahoru: TImage;
    ModulDoleva: TImage;
    ModulDoprava: TImage;
    ModulNL: TImage;
    ModulNP: TImage;
    ModulWTF: TImage;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    LabelP: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure DrawMyGame();
    procedure FormCreate(Sender: TObject);
    procedure GetText();
  private
    X,Y, ID: Integer;
    rX,rY, Vx,Vy, P, L, R: Double;
    Game: String;
    Nahoru, Doleva, Doprava: String;
    Server: String;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GetText();  // Pevod textu ze serveru do promnnch - Rozdlen podle dku, detekce mezer, pevody na klientsk rozhran - 1 jm = 2 px
var
I: Integer;
XLoad: Boolean;
Temp: String;
begin
Xload:=False;
Temp:='';
For i:=1 to Length(Memo1.Lines.Strings[1]) do
begin
  If XLoad = False then
  begin
    If Memo1.Lines.Strings[1][i] = ' ' then
    begin
      Xload := True;
      X := Round(StrToFloat(Temp)*2);
      rX := StrToFloat(Temp);
      Temp:='';
    end
    else
      Temp := Temp + Memo1.Lines.Strings[1][i];
  end
  else
    Temp := Temp + Memo1.Lines.Strings[1][i];
end;
Y := Round(StrToFloat(Temp)*2);
rY := StrToFloat(Temp);

Temp:='';
XLoad := False;

For i:=1 to Length(Memo1.Lines.Strings[2]) do
begin
  If XLoad = False then
  begin
    If Memo1.Lines.Strings[2][i] = ' ' then
    begin
      XLoad := True;
      Vx := StrToFloat(Temp);
      Temp:='';
    end
    else
      Temp := Temp + Memo1.Lines.Strings[2][i];
  end
  else
    Temp := Temp + Memo1.Lines.Strings[2][i];
end;
Vy := StrToFloat(Temp);

P := StrToFloat(Memo1.Lines.Strings[3]);
end;

procedure TForm1.DrawMyGame();   // Vykreslen hry + Jednotliv obrzky pro zaehnut motory
begin
  If (Nahoru = '0') AND (Doleva = '0') AND (Doprava = '0') then
  begin
    Modul.Left:=(X-20);
    Modul.Top:=400-(Y+20);
    Modul.Visible := True;
    ModulNahoru.Visible := False;
    ModulDoleva.Visible := False;
    ModulDoprava.Visible := False;
    ModulNL.Visible := False;
    ModulNP.Visible := False;
    ModulWTF.Visible := False;
  end
  else If (Nahoru = '1') AND (Doleva = '0') AND (Doprava = '0') then
  begin
    ModulNahoru.Left:=(X-20);
    ModulNahoru.Top:=400-(Y+20);
    Modul.Visible := False;
    ModulNahoru.Visible := True;
    ModulDoleva.Visible := False;
    ModulDoprava.Visible := False;
    ModulNL.Visible := False;
    ModulNP.Visible := False;
    ModulWTF.Visible := False;
  end
  else If (Nahoru = '0') AND (Doleva = '1') AND (Doprava = '0') then
  begin
    ModulDoleva.Left:=(X-20);
    ModulDoleva.Top:=400-(Y+20);
    Modul.Visible := False;
    ModulNahoru.Visible := False;
    ModulDoleva.Visible := True;
    ModulDoprava.Visible := False;
    ModulNL.Visible := False;
    ModulNP.Visible := False;
    ModulWTF.Visible := False;
  end
  else If (Nahoru = '0') AND (Doleva = '0') AND (Doprava = '1') then
  begin
    ModulDoprava.Left:=(X-20);
    ModulDoprava.Top:=400-(Y+20);
    Modul.Visible := False;
    ModulNahoru.Visible := False;
    ModulDoleva.Visible := False;
    ModulDoprava.Visible := True;
    ModulNL.Visible := False;
    ModulNP.Visible := False;
    ModulWTF.Visible := False;
  end
  else If (Nahoru = '1') AND (Doleva = '1') AND (Doprava = '0') then
  begin
    ModulNL.Left:=(X-20);
    ModulNL.Top:=400-(Y+20);
    Modul.Visible := False;
    ModulNahoru.Visible := False;
    ModulDoleva.Visible := False;
    ModulDoprava.Visible := False;
    ModulNL.Visible := True;
    ModulNP.Visible := False;
    ModulWTF.Visible := False;
  end
  else If (Nahoru = '1') AND (Doleva = '0') AND (Doprava = '1') then
  begin
    ModulNP.Left:=(X-20);
    ModulNP.Top:=400-(Y+20);
    Modul.Visible := False;
    ModulNahoru.Visible := False;
    ModulDoleva.Visible := False;
    ModulDoprava.Visible := False;
    ModulNL.Visible := False;
    ModulNP.Visible := True;
    ModulWTF.Visible := False;
  end
  else If (Nahoru = '1') AND (Doleva = '1') AND (Doprava = '1') then
  begin
    ModulWTF.Left:=(X-20);
    ModulWTF.Top:=400-(Y+20);
    Modul.Visible := False;
    ModulNahoru.Visible := False;
    ModulDoleva.Visible := False;
    ModulDoprava.Visible := False;
    ModulNL.Visible := False;
    ModulNP.Visible := False;
    ModulWTF.Visible := True;
  end;

  LabelX.Caption:='X: ' + FloatToStr(rX);
  LabelY.Caption:='Y: ' + FloatToStr(rY);
  LabelVx.Caption:='Vx: ' + FloatToStr(Vx);
  LabelVy.Caption:='Vy: ' + FloatToStr(Vy);
  LabelP.Caption:='P: ' + FloatToStr(P);
  Palivo.Progress := Round(P);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
IdHTTP1.Port := SpinEdit1.Value;
Server := Edit1.Text;
Status1.Visible := False;
Status2.Visible := False;
Timer1.Enabled:=True;
Game:='Start';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
Load: Boolean;
Temp: String;
i: Integer;
begin
If Game = 'Run' then // Kdy hra b / Modul let
begin
DXInput1.Update;                 // Natn klvesnice (DirectX)
with DXInput1.Keyboard do
  begin
    if (isRight in States) then
      Doprava:='1'
    else
      Doprava:='0';
    if (isLeft in States) then
      Doleva:='1'
    else
      Doleva:='0';
    if (isUp in States) then
      Nahoru:='1'
    else
      Nahoru:='0';
  end;

Memo1.Clear;
Memo1.Lines.Add(IdHTTP1.Get('http://' + server + '/stav?id=' + IntToStr(id) + '&nahoru=' + nahoru + '&doleva=' + doleva + '&doprava=' + doprava));    // Posln pkazu
If Memo1.Lines.Strings[0] = 'Zdar!' then  // Kdy skon hra - Vzstv
begin
Game:='Konec';
Status1.Caption := 'We have a winner!!';
Status2.Caption := 'Landing module!!';
Status1.Font.Color:=ClGreen;
Status2.Font.Color:=ClGreen;
Status1.Visible := True;
Status2.Visible := True;
Timer1.Enabled := False;
end
else if Memo1.Lines.Strings[0] = 'Krach!' then  // Kdy skon hra - Prohra
begin
Game:='Konec';
Status1.Caption := 'We have a winner!!';
Status2.Caption := 'Moon!!';
Status1.Font.Color:=clMaroon;
Status2.Font.Color:=clMaroon;
Status1.Visible := True;
Status2.Visible := True;
Timer1.Enabled := False;
end
else
begin
Memo1.Text := StringReplace(Memo1.Text,'.',',', [rfReplaceAll]);
GetText(); // Rozdlen textu ze serveru do promnnch
DrawMyGame();  // Vykreslen hry
end;
end
else if Game = 'Start' then   // Kdy hra zan
begin
Game:='Run';
Memo1.Clear;
Memo1.Lines.Add(IdHTTP1.Get('http://' + server + '/start'));
Memo1.Text := StringReplace(Memo1.Text,'.',',', [rfReplaceAll]);
ID:=StrToInt(Memo1.Lines.Strings[0]);
GetText();
Load:=False;
Temp:='';
For i:=1 to Length(Memo1.Lines.Strings[4]) do
begin
  If Load = False then
  begin
    If Memo1.Lines.Strings[4][i] = ' ' then
    begin
      Load := True;
      L := StrToFloat(Temp);
      Temp:='';
    end
    else
      Temp := Temp + Memo1.Lines.Strings[4][i];
  end
  else
    Temp := Temp + Memo1.Lines.Strings[4][i];
end;
R := StrToFloat(Temp);

Plocha.Left := Round(L*2);
Plocha.Width := Round(R*2)-Round(L*2);
LabelL.Caption := FloatToStr(L);
LabelR.Caption := FloatToStr(R);

Palivo.MaxValue := Round(P);
Palivo.Progress := Round(P);

DrawMyGame(); // Vykreslovn hry
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
DoubleBuffered:=True;
end;

end.
